diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/CMakeLists.txt ns-3.36/src/fd-net-device/CMakeLists.txt
--- ns-3.35/src/fd-net-device/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/fd-net-device/CMakeLists.txt	2022-04-30 18:23:57.838733400 -0700
@@ -0,0 +1,332 @@
+option(
+  NS3_DPDK
+  "Enable fd-net-device DPDK features"
+  OFF
+)
+
+set(module_enabled_features) # modulegen_customizations consumes this list
+
+mark_as_advanced(ENABLE_THREADING)
+set(ENABLE_THREADING
+    ${HAVE_PTHREAD_H}
+)
+
+check_include_file_cxx(
+  net/ethernet.h
+  HAVE_NET_ETHERNET_H
+)
+check_include_file_cxx(
+  netpacket/packet.h
+  HAVE_PACKET_H
+)
+check_include_file_cxx(
+  net/if.h
+  HAVE_IF_NETS_H
+)
+check_include_file_cxx(
+  linux/if_tun.h
+  HAVE_IF_TUN_H
+)
+check_include_file_cxx(
+  net/netmap_user.h
+  HAVE_NETMAP_USER_H
+)
+check_include_file_cxx(
+  sys/ioctl.h
+  HAVE_SYS_IOCTL_H
+)
+
+include(FindPkgConfig)
+if(PKG_CONFIG_FOUND)
+  pkg_check_modules(
+    DPDK
+    libdpdk
+  )
+endif()
+
+mark_as_advanced(
+  ENABLE_FDNETDEV
+  ENABLE_DPDKDEVNET
+  ENABLE_TAPNETDEV
+  ENABLE_EMUNETDEV
+  ENABLE_NETMAP_EMU
+)
+set(ENABLE_FDNETDEV
+    False
+    CACHE INTERNAL
+          ""
+)
+set(ENABLE_DPDKDEVNET
+    False
+    CACHE INTERNAL
+          ""
+)
+set(ENABLE_TAPNETDEV
+    False
+    CACHE INTERNAL
+          ""
+)
+set(ENABLE_EMUNETDEV
+    False
+    CACHE INTERNAL
+          ""
+)
+set(ENABLE_NETMAP_EMU
+    False
+    CACHE INTERNAL
+          ""
+)
+
+if(HAVE_NET_ETHERNET_H)
+  set(ENABLE_FDNETDEV
+      True
+      CACHE INTERNAL
+            ""
+  )
+
+  if(${NS3_DPDK})
+    if(PKG_CONFIG_FOUND)
+      if(DPDK_FOUND)
+
+        set(ENABLE_DPDKDEVNET
+            True
+            CACHE INTERNAL
+                  ""
+        )
+      else()
+        message(FATAL_ERROR "DPDK not found.")
+      endif()
+    else()
+      message(FATAL_ERROR "Pkgconfig was not found and is required by DPDK.")
+    endif()
+  endif()
+
+  if(HAVE_IF_NETS_H
+     AND HAVE_IF_TUN_H
+     AND HAVE_SYS_IOCTL_H
+     AND ${ENABLE_TAP}
+     AND ${ENABLE_REALTIME}
+     AND ${ENABLE_EMU}
+  )
+    set(ENABLE_TAPNETDEV
+        True
+        CACHE INTERNAL
+              ""
+    )
+  endif()
+
+  if(HAVE_IF_NETS_H
+     AND HAVE_PACKET_H
+     AND HAVE_SYS_IOCTL_H
+     AND ${ENABLE_EMU}
+  )
+    set(ENABLE_EMUNETDEV
+        True
+        CACHE INTERNAL
+              ""
+    )
+    add_definitions(-DHAVE_PACKET_H)
+  endif()
+
+  if(HAVE_IF_NETS_H
+     AND HAVE_NETMAP_USER_H
+     AND HAVE_SYS_IOCTL_H
+  )
+    set(ENABLE_NETMAP_EMU
+        True
+        CACHE INTERNAL
+              ""
+    )
+    add_definitions(-DHAVE_NETMAP_USER_H)
+  endif()
+endif()
+
+if(${ENABLE_FDNETDEV})
+  set(fd-net-device_creators)
+  list(
+    APPEND
+    module_enabled_features
+    FdNetDevice
+  )
+
+  if(${ENABLE_EMUNETDEV})
+    set(emu_sources
+        helper/emu-fd-net-device-helper.cc
+    )
+    set(emu_headers
+        helper/emu-fd-net-device-helper.h
+    )
+
+    add_executable(
+      raw-sock-creator
+      helper/creator-utils.cc
+      helper/encode-decode.cc
+      helper/raw-sock-creator.cc
+    )
+    add_definitions(
+      -DRAW_SOCK_CREATOR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/ns${NS3_VER}-raw-sock-creator${build_profile_suffix}"
+    )
+    set_runtime_outputdirectory(
+      raw-sock-creator
+      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/
+      ""
+    )
+
+    list(
+      APPEND
+      fd-net-device_creators
+      raw-sock-creator
+    )
+    list(
+      APPEND
+      module_enabled_features
+      EmuFdNetDevice
+    )
+  endif()
+
+  if(${ENABLE_TAPNETDEV})
+    set(tap_sources
+        helper/tap-fd-net-device-helper.cc
+    )
+    set(tap_headers
+        helper/tap-fd-net-device-helper.h
+    )
+
+    add_executable(
+      tap-device-creator
+      helper/creator-utils.cc
+      helper/encode-decode.cc
+      helper/tap-device-creator.cc
+    )
+    add_definitions(
+      -DTAP_DEV_CREATOR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/ns${NS3_VER}-tap-device-creator${build_profile_suffix}"
+    )
+    set_runtime_outputdirectory(
+      tap-device-creator
+      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/
+      ""
+    )
+
+    list(
+      APPEND
+      fd-net-device_creators
+      tap-device-creator
+    )
+    list(
+      APPEND
+      module_enabled_features
+      TapFdNetDevice
+    )
+  endif()
+
+  if(${ENABLE_NETMAP_EMU})
+    set(netmap_sources
+        helper/netmap-net-device-helper.cc
+        model/netmap-net-device.cc
+    )
+    set(netmap_headers
+        helper/netmap-net-device-helper.h
+        model/netmap-net-device.h
+    )
+
+    add_executable(
+      netmap-device-creator
+      helper/creator-utils.cc
+      helper/encode-decode.cc
+      helper/netmap-device-creator.cc
+    )
+    add_definitions(
+      -DNETMAP_DEV_CREATOR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/ns${NS3_VER}-netmap-device-creator${build_profile_suffix}"
+    )
+    set_runtime_outputdirectory(
+      netmap-device-creator
+      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/
+      ""
+    )
+
+    list(
+      APPEND
+      fd-net-device_creators
+      netmap-device-creator
+    )
+  endif()
+
+  if(${ENABLE_DPDKDEVNET})
+    set(dpdk_sources
+        model/dpdk-net-device.cc
+        helper/dpdk-net-device-helper.cc
+    )
+    set(dpdk_headers
+        model/dpdk-net-device.h
+        helper/dpdk-net-device-helper.h
+    )
+    add_definitions(-DHAVE_DPDK_USER_H)
+    set(dpdk_libraries
+        ${LIB_AS_NEEDED_PRE}
+        ${DPDK_LIBRARIES}
+        ${LIB_AS_NEEDED_POST}
+    )
+  endif()
+
+  set(source_files
+      ${tap_sources}
+      ${emu_sources}
+      ${netmap_sources}
+      ${dpdk_sources}
+      helper/creator-utils.cc
+      helper/encode-decode.cc
+      helper/fd-net-device-helper.cc
+      model/fd-net-device.cc
+  )
+
+  set(header_files
+      ${tap_headers}
+      ${emu_headers}
+      ${netmap_headers}
+      ${dpdk_headers}
+      model/fd-net-device.h
+      helper/fd-net-device-helper.h
+  )
+
+  set(libraries_to_link
+      ${libnetwork}
+      ${dpdk_libraries}
+  )
+
+  set(test_sources)
+
+  build_lib(
+    LIBNAME fd-net-device
+    SOURCE_FILES ${source_files}
+    HEADER_FILES ${header_files}
+    LIBRARIES_TO_LINK ${libraries_to_link}
+    TEST_SOURCES ${test_sources}
+    MODULE_ENABLED_FEATURES ${module_enabled_features}
+  )
+
+  if(${ENABLE_DPDKDEVNET})
+    target_include_directories(
+      ${libfd-net-device-obj}
+      PRIVATE ${DPDK_INCLUDE_DIRS}
+    )
+    target_compile_options(
+      ${libfd-net-device-obj}
+      PRIVATE ${DPDK_CFLAGS}
+    )
+  endif()
+
+  list(
+    LENGTH
+    fd-net-device_creators
+    num_creators
+  )
+  if(${num_creators}
+     GREATER
+     0
+  )
+    add_dependencies(
+      ${libfd-net-device}
+      ${fd-net-device_creators}
+    )
+  endif()
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/CMakeLists.txt ns-3.36/src/fd-net-device/examples/CMakeLists.txt
--- ns-3.35/src/fd-net-device/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/fd-net-device/examples/CMakeLists.txt	2022-04-30 18:23:57.842733400 -0700
@@ -0,0 +1,112 @@
+include_directories(${DPDK_INCLUDE_DIRS})
+
+build_lib_example(
+  NAME dummy-network
+  SOURCE_FILES dummy-network.cc
+  LIBRARIES_TO_LINK
+    ${libfd-net-device}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_lib_example(
+  NAME fd2fd-onoff
+  SOURCE_FILES fd2fd-onoff.cc
+  LIBRARIES_TO_LINK
+    ${libfd-net-device}
+    ${libinternet}
+    ${libapplications}
+)
+
+if(${ENABLE_REALTIME})
+  build_lib_example(
+    NAME realtime-dummy-network
+    SOURCE_FILES realtime-dummy-network.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+      ${libinternet-apps}
+  )
+
+  build_lib_example(
+    NAME realtime-fd2fd-onoff
+    SOURCE_FILES realtime-fd2fd-onoff.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+  )
+endif()
+
+if(${ENABLE_EMU})
+  build_lib_example(
+    NAME fd-emu-ping
+    SOURCE_FILES fd-emu-ping.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libinternet-apps}
+  )
+
+  build_lib_example(
+    NAME fd-emu-udp-echo
+    SOURCE_FILES fd-emu-udp-echo.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+  )
+
+  build_lib_example(
+    NAME fd-emu-onoff
+    SOURCE_FILES fd-emu-onoff.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+  )
+
+  build_lib_example(
+    NAME fd-emu-send
+    SOURCE_FILES fd-emu-send.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+      ${libinternet-apps}
+      ${libtraffic-control}
+  )
+
+  build_lib_example(
+    NAME fd-emu-tc
+    SOURCE_FILES fd-emu-tc.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libapplications}
+      ${libinternet-apps}
+      ${libtraffic-control}
+  )
+endif()
+
+if(${ENABLE_TAPNETDEV})
+  build_lib_example(
+    NAME fd-tap-ping
+    SOURCE_FILES fd-tap-ping.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libinternet-apps}
+  )
+
+  build_lib_example(
+    NAME fd-tap-ping6
+    SOURCE_FILES fd-tap-ping6.cc
+    LIBRARIES_TO_LINK
+      ${libfd-net-device}
+      ${libinternet}
+      ${libinternet-apps}
+      ${libcsma}
+  )
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/fd2fd-onoff.cc ns-3.36/src/fd-net-device/examples/fd2fd-onoff.cc
--- ns-3.35/src/fd-net-device/examples/fd2fd-onoff.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/examples/fd2fd-onoff.cc	2022-04-30 18:23:57.842733400 -0700
@@ -37,8 +37,8 @@
 //
 // Steps to run the experiment:
 //
-// $ ./waf --run="fd2fd-onoff"
-// $ ./waf --run="fd2fd-onoff --tcpMode=1"
+// $ ./ns3 run="fd2fd-onoff"
+// $ ./ns3 run="fd2fd-onoff --tcpMode=1"
 //
 
 #include <sys/socket.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/fd-emu-onoff.cc ns-3.36/src/fd-net-device/examples/fd-emu-onoff.cc
--- ns-3.35/src/fd-net-device/examples/fd-emu-onoff.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/examples/fd-emu-onoff.cc	2022-04-30 18:23:57.842733400 -0700
@@ -78,7 +78,7 @@
 //      build netmap/dpdk separately.
 //
 // 4 - Give root suid to the raw or netmap socket creator binary.
-//     If the --enable-sudo option was used to configure ns-3 with waf, then the following
+//     If the --enable-sudo option was used to configure ns-3 with ns3, then the following
 //     step will not be necessary.
 //
 // both hosts: $ sudo chown root.root build/src/fd-net-device/ns3-dev-raw-sock-creator
@@ -96,11 +96,11 @@
 //
 // 6 - Run the server side:
 //
-// server host: $ ./waf --run="fd-emu-onoff --serverMode=1"
+// server host: $ ./ns3 run="fd-emu-onoff --serverMode=1"
 //
 // 7 - Run the client side:
 //
-// client host: $ ./waf --run="fd-emu-onoff"
+// client host: $ ./ns3 run="fd-emu-onoff"
 //
 
 #include <iostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/fd-emu-ping.cc ns-3.36/src/fd-net-device/examples/fd-emu-ping.cc
--- ns-3.35/src/fd-net-device/examples/fd-emu-ping.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/examples/fd-emu-ping.cc	2022-04-30 18:23:57.842733400 -0700
@@ -69,7 +69,7 @@
 //     on your host.  Search for "Ipv4Address gateway" and replace the string
 //     "1.2.3.4" string with the gateway IP address.
 //  6) Give root suid to the raw or netmap socket creator binary.
-//     If the --enable-sudo option was used to configure ns-3 with waf, then the following
+//     If the --enable-sudo option was used to configure ns-3 with ns3, then the following
 //     step will not be necessary.
 //
 //     $ sudo chown root.root build/src/fd-net-device/ns3-dev-raw-sock-creator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/fd-tap-ping.cc ns-3.36/src/fd-net-device/examples/fd-tap-ping.cc
--- ns-3.35/src/fd-net-device/examples/fd-tap-ping.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/examples/fd-tap-ping.cc	2022-04-30 18:23:57.842733400 -0700
@@ -19,26 +19,26 @@
 // Allow ns-3 to ping a real host somewhere, using emulation mode and ping
 // the simulated node from the host.
 //
-//   +-------------------------------------+    
+//   +-------------------------------------+
 //   |                host                 |
-//   +-------------------------------------+    
-//   |    ns-3 simulation   |              |                       
-//   +----------------------+              |    
-//   |       ns-3 Node      |              |   
-//   |  +----------------+  |              |   
-//   |  |    ns-3 TCP    |  |              |   
-//   |  +----------------+  |              |   
-//   |  |    ns-3 IPv4   |  |              |   
-//   |  +----------------+  |              |   
-//   |  |   FdNetDevice  |  |              |  
+//   +-------------------------------------+
+//   |    ns-3 simulation   |              |
+//   +----------------------+              |
+//   |       ns-3 Node      |              |
+//   |  +----------------+  |              |
+//   |  |    ns-3 TCP    |  |              |
+//   |  +----------------+  |              |
+//   |  |    ns-3 IPv4   |  |              |
+//   |  +----------------+  |              |
+//   |  |   FdNetDevice  |  |              |
 //   |--+----------------+--+    +------+  |
-//   |       | TAP  |            | eth0 |  | 
+//   |       | TAP  |            | eth0 |  |
 //   |       +------+            +------+  |
 //   |       1.2.3.4                 |     |
-//   +-------------------------------|-----+ 
+//   +-------------------------------|-----+
 //                                   |
 //                                   |                             +-------------+
-//                                   ------------ (Internet) ----- | Remote host |                            
+//                                   ------------ (Internet) ----- | Remote host |
 //                                                                 +-------------+
 //
 // To use this example:
@@ -51,22 +51,22 @@
 //     So for Linux systems, make sure to configure:
 //     # echo 1 > /proc/sys/net/ipv4/ip_forward
 //
-//     Also enable natting so the ICMP replies from the remote host can reach 
-//     back the TAP. 
+//     Also enable natting so the ICMP replies from the remote host can reach
+//     back the TAP.
 //     - TAP-network-address is the same as 'tapNetwork'
 //     - TAP-network-mask is the same as 'tapMask'
 //     # iptables -t nat -A POSTROUTING -s <TAP-network-address>/<TAP-network-mask> -j MASQUERADE
 //
 //  3) Before running the example make sure that the tap creator binary has root suid.
-//     If the --enable-sudo option was used to configure ns-3 with waf, then the following
+//     If the --enable-sudo option was used to configure ns-3 with ns3, then the following
 //     step will not be necessary.
 //
 //     # chown root.root build/src/fd-net-device/ns3-dev-tap-device-creator
 //     # sudo chmod 4755 build/src/fd-net-device/ns3-dev-tap-device-creator
 //
-//  4)  The example can be executed as follows using waf:
-//  
-//     ./waf --run fd-tap-ping --command-template="%s --tapNetwork=<TAP-network-address> --tapMask=<TAP-network-mask>" 
+//  4)  The example can be executed as follows using ns3:
+//
+//     ./ns3 run fd-tap-ping --command-template="%s --tapNetwork=<TAP-network-address> --tapMask=<TAP-network-mask>"
 //
 
 #include "ns3/abort.h"
@@ -117,7 +117,7 @@
   Ipv4Address tapNetwork (network.c_str ());
   Ipv4Mask tapMask (mask.c_str ());
 
-  bool modePi = ( pi == "yes" ? true : false);
+  bool modePi = (pi == "yes");
 
   //
   // Since we are using a real piece of hardware we need to use the realtime
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/examples/realtime-fd2fd-onoff.cc ns-3.36/src/fd-net-device/examples/realtime-fd2fd-onoff.cc
--- ns-3.35/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2022-04-30 18:23:57.846733600 -0700
@@ -37,7 +37,7 @@
 //
 // Steps to run the experiment:
 //
-// $ ./waf --run="fd2fd-onoff"
+// $ ./ns3 run="fd2fd-onoff"
 //
 
 #include <sys/socket.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/helper/emu-fd-net-device-helper.h ns-3.36/src/fd-net-device/helper/emu-fd-net-device-helper.h
--- ns-3.35/src/fd-net-device/helper/emu-fd-net-device-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/helper/emu-fd-net-device-helper.h	2022-04-30 18:23:57.846733600 -0700
@@ -80,6 +80,7 @@
 
   /**
    * Sets a file descriptor on the FileDescriptorNetDevice.
+   * \param device the device to install the file descriptor in
    */
   virtual void SetFileDescriptor (Ptr<FdNetDevice> device) const;
 
@@ -94,7 +95,7 @@
    * The Unix/Linux name of the underlying device (e.g., eth0)
    */
   std::string m_deviceName;
-  bool m_hostQdiscBypass;
+  bool m_hostQdiscBypass; //!< True if request host qdisc bypass
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/helper/fd-net-device-helper.h ns-3.36/src/fd-net-device/helper/fd-net-device-helper.h
--- ns-3.35/src/fd-net-device/helper/fd-net-device-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/helper/fd-net-device-helper.h	2022-04-30 18:23:57.846733600 -0700
@@ -57,7 +57,7 @@
   /**
    * Set the TypeId of the Objects to be created by this helper.
    *
-   * \param [in] tid The TypeId of the object to instantiate.
+   * \param [in] type The TypeId of the object to instantiate.
    */
   void SetTypeId (std::string type);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/helper/tap-fd-net-device-helper.h ns-3.36/src/fd-net-device/helper/tap-fd-net-device-helper.h
--- ns-3.35/src/fd-net-device/helper/tap-fd-net-device-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/helper/tap-fd-net-device-helper.h	2022-04-30 18:23:57.846733600 -0700
@@ -105,12 +105,14 @@
 
   /**
    * Sets a file descriptor on the FileDescriptorNetDevice.
+   * \param device the device to install the file descriptor in
    */
   virtual void SetFileDescriptor (Ptr<FdNetDevice> device) const;
 
   /**
    * Call out to a separate process running as suid root in order to create a
    * TAP device and obtain the file descriptor associated to it.
+   * \returns The file descriptor associated with the TAP device.
    */
   virtual int CreateFileDescriptor (void) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/model/dpdk-net-device.cc ns-3.36/src/fd-net-device/model/dpdk-net-device.cc
--- ns-3.35/src/fd-net-device/model/dpdk-net-device.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/model/dpdk-net-device.cc	2022-04-30 18:23:57.846733600 -0700
@@ -25,8 +25,6 @@
 #include "ns3/log.h"
 #include "ns3/net-device-queue-interface.h"
 #include "ns3/simulator.h"
-#include "ns3/system-thread.h"
-#include "ns3/system-condition.h"
 #include "ns3/system-mutex.h"
 #include "ns3/uinteger.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/model/dpdk-net-device.h ns-3.36/src/fd-net-device/model/dpdk-net-device.h
--- ns-3.35/src/fd-net-device/model/dpdk-net-device.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/model/dpdk-net-device.h	2022-04-30 18:23:57.846733600 -0700
@@ -96,6 +96,8 @@
 
   /**
    * A function to handle rx & tx operations.
+   * \param arg a pointer to the DpdkNetDevice
+   * \return zero on failure or exit.
    */
   static int LaunchCore (void *arg);
 
@@ -117,11 +119,14 @@
 
   /**
    * Free the given packet buffer.
+   * \param buf the pointer to the buffer to be freed
    */
   virtual void FreeBuffer (uint8_t* buf);
 
   /**
    * Allocate packet buffer.
+   * \param len the length of the buffer
+   * \return A pointer to the newly created buffer.
    */
   virtual uint8_t* AllocateBuffer (size_t len);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/model/fd-net-device.h ns-3.36/src/fd-net-device/model/fd-net-device.h
--- ns-3.35/src/fd-net-device/model/fd-net-device.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/model/fd-net-device.h	2022-04-30 18:23:57.846733600 -0700
@@ -59,6 +59,7 @@
 
   /**
    * Set size of the read buffer.
+   * \param bufferSize the buffer size
    */
   void SetBufferSize (uint32_t bufferSize);
 
@@ -115,6 +116,9 @@
    */
   virtual ~FdNetDevice ();
 
+  // Delete assignment operator to avoid misuse
+  FdNetDevice (FdNetDevice const &) = delete;
+
   /**
    * Set the link layer encapsulation mode of this device.
    *
@@ -132,7 +136,7 @@
 
   /**
    * Set the associated file descriptor.
-   *
+   * \param fd the file descriptor
    */
   void SetFileDescriptor (int fd);
 
@@ -211,16 +215,21 @@
 
   /**
    * Allocate packet buffer.
+   * \param len the length of the buffer
+   * \return A pointer to the newly allocated buffer.
    */
-  virtual uint8_t* AllocateBuffer(size_t len);
+  virtual uint8_t* AllocateBuffer (size_t len);
 
   /**
    * Free the given packet buffer.
+   * \param buf the buffer to free
    */
   virtual void FreeBuffer (uint8_t* buf);
 
   /**
    * Callback to invoke when a new frame is received
+   * \param buf a buffer containing the received frame
+   * \param len the length of the frame
    */
   void ReceiveCallback (uint8_t *buf, ssize_t len);
 
@@ -236,14 +245,6 @@
 
 private:
   /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse as suggested in
-   * http://www.nsnam.org/wiki/NS-3_Python_Bindings#.22invalid_use_of_incomplete_type.22
-   */
-  FdNetDevice (FdNetDevice const &);
-
-  /**
    * Spin up the device
    */
   void StartDevice (void);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/fd-net-device/model/netmap-net-device.h ns-3.36/src/fd-net-device/model/netmap-net-device.h
--- ns-3.35/src/fd-net-device/model/netmap-net-device.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/fd-net-device/model/netmap-net-device.h	2022-04-30 18:23:57.846733600 -0700
@@ -179,15 +179,15 @@
 
   /**
    * \brief Set the netmap receiver rings info
-   * \param nTxRings the number of receiver rings
-   * \param nTxRingsSlots the number of slots for each receiver ring
+   * \param nRxRings the number of receiver rings
+   * \param nRxRingsSlots the number of slots for each receiver ring
    */
   void SetRxRingsInfo (uint32_t nRxRings, uint32_t nRxRingsSlots);
 
   /**
    * \brief The function Writes a packet into the netmap transmission ring.
    * \param buffer the pointer to packet
-   * \param lenght the packet lenght
+   * \param length the packet length
    * \return the number of written bytes
    */
   virtual ssize_t Write (uint8_t *buffer, size_t length);
